#commandset WildCard Rolling
#register /w WildCard Wild Card rolling for use with Savage Worlds. Rolls open ended dice and an open ended d6 and adds or subtracts modifiers. Some examples: /w 4, /w d8 or /w 1d8, /w 3d6, /w 10+3, /w d12+5, /w 1d6-2.
'Works with any sided dice.  
'Example: "/w 10" rolls an open ended d10 and an open ended d6.

Sub WildCard
' *** Get the information from the chat window
cs = GetChatSession()
ci = cs.GetLastItem()

COMMAND =  Trim(ci.Text)
Dee = Cstr(Instr(COMMAND, "d"))

' *** Check for the d and build the command if not 4d6 format
If Dee = 0 Then
   Command = "1d" & Command
   Dee = 2
Else
   If Dee = 1 Then
      Command = "1" & Command
      Dee = 2
   End If
End If

'Figure out the modified command length 
Length = Len(Command)
Plus = Cstr(Instr(COMMAND, "+"))
Minus = Cstr(Instr(COMMAND, "-"))

' *** Extract number of dice
NumOfDice = Left(COMMAND, Dee-1)
RemCommand = Right(COMMAND, Length-Dee)


' *** Extract the die type (NUMBER) and modifier
If Plus <> 0 Then
   Modifier = Right(COMMAND, Length-(Plus-1))
   Number = Left(COMMAND, Plus-1)
   Number = Right(Number, Len(Number)-Dee)
Else
   If Minus <> 0 Then
      Modifier = Right(COMMAND, Length-(Minus-1))
      Number = Left(COMMAND, Minus-1)
      Number = Right(Number, Len(Number)-Dee)
   Else
      Modifier = "0"
      Number = RemCommand
   End If
End If

' *** Define the variables
NUMBER = CInt( Number)
MODIFIER = CInt (Modifier)
NumOfDice = CInt (NumOfDice)
DIETYPE = "1d" & NUMBER
WILDDIETYPE = "1d6"
WILDNUMBER = 6
TOTALROLL = 0
WILDTOTALROLL = 0 

' *** Check for Open Ended d1 - Not a good idea
If NUMBER = 1 Then
   ci.PlayerFrom = "Common Sense"
   ci.Text = "<i>can't roll an open ended 1!</i>"
   Exit Sub
End If

DESCRIPTIVESUM = ""

For Count = 1 to NumOfDice 
   '*** Roll the requested Die Type
   TotalRoll = SavageRoll(Number) 
   If TotalRoll = 1 Then
      OneOnSkill = True
   End If
   TotalRoll = TotalRoll + MODIFIER
   DESCRIPTIVESUM = DESCRIPTIVESUM & "<b>" & TOTALROLL & "</b>(d" & Number 
   If Modifier > 0 Then
      DESCRIPTIVESUM = DESCRIPTIVESUM & "+" & MODIFIER
   Else
      If Modifier < 0 Then
         DESCRIPTIVESUM = DESCRIPTIVESUM & MODIFIER
      End If
   End If
   DESCRIPTIVESUM = DESCRIPTIVESUM & "), "   

Next


' *** Roll a wild Die
WildTotalRoll = SavageRoll(6)
   If WildTotalRoll = 1 Then
      OneOnWild = True
   End If
WildTotalRoll = WildTotalRoll + MODIFIER


DESCRIPTIVESUM = DESCRIPTIVESUM & "<b>" & WILDTOTALROLL & "</b>(Wild"
If Modifier > 0 Then
   DESCRIPTIVESUM = DESCRIPTIVESUM & "+" & MODIFIER
Else
   If Modifier < 0 Then
      DESCRIPTIVESUM = DESCRIPTIVESUM & MODIFIER
   End If
End If
DESCRIPTIVESUM = DESCRIPTIVESUM & ")"   


If OneOnSkill Then
   If OneOnWild Then
      DESCRIPTIVESUM = "/red "  & DESCRIPTIVESUM & "\n A Critical Failure!"
   Else 
      DESCRIPTIVESUM = "/red " & DESCRIPTIVESUM & "\n Note:1 on Skill Die!"
   End If
End If

ci.Text = DESCRIPTIVESUM

End Sub




' This function Rolls an open ended die and returns the total result


Function SavageRoll(NUMBER)

TOTALROLL = 0
ROLLOVERS = 0
NUMBER = CInt( NUMBER)
DIETYPE = "1d" & NUMBER

'*** Roll the requested Die Type
Do While true
' *** Continue to 100 rollovers
   If ROLLOVERS > 100 Then
     Exit Do
   End If

' *** Roll the Die
   DIEROLL = EvalDice(DIETYPE)
   ' *** Add to the total
   TOTALROLL = TOTALROLL + DIEROLL

   ' *** See if it is a rollover
   If DIEROLL <> NUMBER Then
      ' *** Not a rollover
      If ROLLOVERS > 0 Then
      End If
      Exit Do
   End If
   ' *** Is a rollover so add a plus sign 
   ROLLOVERS = ROLLOVERS + 1
Loop

   SavageRoll = TOTALROLL
End Function   